// Tomasz Dudziak, F1-ISI

//boost::optional - Biblioteka oferujca adapter rozszerzajcy dowolny typ o warto niezdefiniowan/niezainicjowan.
//Sowo optional oznacza, e dany obiekt moe zupenie opcjonalnie przyjmowa jakkolwiek warto, gdy moe jej rwnie dobrze nie mie.
//Oczywicie moliwe jest sprawdzenie, czy dany obiekt jest zainicjowany, czy nie oraz uczynienie go w pewnym momencie niezainicjowanym. 
//Dziki przecieniu operatorw obsuga obiektw optional jest zbliona do obsugi zmiennych.
#include<boost\optional.hpp>
#include<iostream>
#include<math.h>

using namespace std;
using namespace boost;

//Klasa Mathematician peni rol klasy obiektu "czarnej skrzynki". Nie interesuj nas szczegy dziaania jej metod, wiemy natomiast,
//e moemy otrzyma albo sensowny wynik, albo nieokrelon warto (gdy obliczenie wyniku jest niemoliwe). W tym wypadku interesuje
//nas obliczenie pierwiastka kwadratowego zadanej liczby. Jak wiadomo, dla liczb nieujemnych istnieje poprawny wynik, a dla liczb ujemnych nie.
class Mathematician
{
public:
	//Metoda countSquareRoot oblicza pierwiastek dla nieujemnego argumentu. Dla argumentu ujemnego wynik pozostaje niezdefiniowany.
	void countSquareRoot(double argument)
	{
		opt_result_=optional<double>(); //uniewanienie wyniku na pocztku (przypisanie wartoci niezdefiniowanej)
		//Funkcja make_optional pozwala na przeksztacenie danej liczby w obiekt optional, przy spenieniu okrelonego warunku.
		//Tutaj obliczenie pierwiastka liczby, a nastpnie przetumaczenie go na obiekt optional jest uzalenione od tego, czy
		//liczba jest nieujemna.
		opt_result_=make_optional<double>((argument>=0),sqrt(argument));			
	}
	
	//Pobranie wyniku.
	optional<double> getResult()
	{
		return opt_result_;
	}

private:
	optional<double> opt_result_; //Skadowa, w ktrej przechowywany jest wynik (okrelona liczba, lub niezdefiniowany).
};


int main()
{
	char ch='t'; //litera podawana przez uytkownika umoliwiajca wyjcie z ptli programu lub pozostanie w niej
	double liczba; //liczba podawana przez uytkownika
	optional<double> opt_wynik; //obiekt przechowujcy wynik typu optional
	Mathematician mathematician; //obiekt wykonujcy dla nas obliczenia
	
	while(ch!='n')
	{
		//Pobranie od uytkownika dowolnej liczby
		cout<<"Podaj jakas liczbe dodatnia lub ujemna: ";
		cin>>liczba;
		cout<<endl;
		fflush(stdin);

		//Dokonanie oblicze przez obiekt matematyka
		mathematician.countSquareRoot(liczba);
		opt_wynik=mathematician.getResult(); //Pobranie wyniku od matematyka

		if(!opt_wynik) //Jeli wynik jest niezdefiniowany, informacja o tym dla uytkownika
			cout<<"Nie istnieje pierwiastek dla tej liczby."<<endl;
		else //jeli wynik ma okrelon warto - podanie wyniku (warto mona otrzyma przy uyciu operatora *)
			cout<<"Obliczono pierwiastek dla podanej liczby: "<<*opt_wynik<<endl;

		//Dla n wyjcie z ptli, dla pozostaych liter kolejna iteracja
		cout<<endl<<"Aby powtorzyc dla nowej liczby, podaj inna litere niz 'n': ";
		cin.clear();
		cin>>ch;
		cout<<endl;
		fflush(stdin);
	}
	
	return 0;
}